

    '           **********************************************
    '           ***                                        ***
    '           ***      GUIglobeOtherProjns05b.bas        ***
    '           ***                                        ***
    '           **********************************************


    'To-dos:-
    '   <<<  Height has no effect                                       >>>> CORRECTED
    '   <<<  Grid doesn't always fill globe                             >>>> CORRECTED
    '   <<<  Need range checks on A H I LO                              >>>> DONE
    '   <<<  Need to modify 'J' selector to allow more options.         >>>> DONE
    '   <<<  Add file selectors for loading data and saving image.      >>>> DONE
    '   <<<  Lat/l were reversed on original LatLon datafile            >>>> CORRECTED
    '   <<<  Investigate drawing grid with lines                        >>>> DONE
    '   <<<  Add a help file option, and on-screen help.                >>>> DONE
    '   <<<  Add rectangular background and Cartesian Lat/Lon display   >>>> DONE

    '   <<<  Disable /enable 'New'/'Save' buttons appropriately         >>>> Part done

    '   <<<  Add button to opt for N or S polar view if J = 4           >>>>

    nomainwin

    global fileOpen, pi
    fileOpen    =0
    pi          =3.14159265


    '   constants

    E      = 6378.0                    '   Earth radius

    K1     =    1.0
    K2     =    pi / 2                 '   pi /2
    K3     =    pi                     '   pi
    K6     =    2 * pi                 '   2 pi

    T      =    0.00015                '   test value
    Z      =    0.0

    R      =  300                      '   map size in pixels /cm

    CR$     =chr$( 13 )


    BackgroundColor$ = "lightgray"

    WindowWidth  =1210
    WindowHeight = 780

    textbox    #w.tb1, 320,  52,  80,  30
    textbox    #w.tb2, 320,  97,  80,  30
    textbox    #w.tb3, 320, 141,  80,  30
    textbox    #w.tb4, 320, 184,  80,  30
    textbox    #w.tb5, 320, 234,  80,  30

    statictext #w.st1,  " A  -latitude  /degrees" +CR$ +CR$_
                       +" H  -height    /m"_
            +CR$ + CR$ +" I  -azimuth   /degrees" +CR$_
            +CR$       +" LO -longitude /degrees"_
            +CR$ + "--------------------" +CR$_
                      + " 0 =perspective" +CR$_
                      + " 1 =mod'd persp'ive" + CR$_
                      + " 2 =azimuthal equidistant"_
            + CR$     + " 3 =polar equidistant" +CR$_
                      + " 4 =ortho equatorial"_
            + CR$     + " 5 =Cartesian Lat /Lon",   9, 55, 300, 340

    graphicbox #w.gb,  410,  20, 780, 725

    button     #w.b1 "New",  [dataShow], LR, 850, 430,  70,  30
    button     #w.b2 "Save", [saveScr],  LR, 850, 390,  70,  30

    menu       #w,    "&Help file", "&Guide", [guide]



    open "World Views- Assorted Projections" for window_nf as #w


    #w "trapclose quit"

    #w.st1 "!font Courier_New 14 bold"

    #w.b1  "!font Courier_New 14 bold"
    #w.b2  "!font Courier_New 14 bold"

    #w.tb1 "!font Courier_New 14 bold"
    #w.tb2 "!font Courier_New 14 bold"
    #w.tb3 "!font Courier_New 14 bold"
    #w.tb4 "!font Courier_New 14 bold"
    #w.tb5 "!font Courier_New 14 bold"

    #w.tb1 "0"
    #w.tb2 "1e8"
    #w.tb3 "0"
    #w.tb4 "0"
    #w.tb5 "0"

    #w.b1 "!disable"
    '#w.b2 "!disable"

    R       =300    '   size of screen globe
    D       =  3    '   dia in inches of map??<<<<<<<<<<<<<<<<<

[dataShow]
    #w.tb1 "!contents? inA$":  A  = val( inA$  ) *pi /180: #w.tb1 inA$:     if A > 90 or A < 0 -90              then wait
    #w.tb2 "!contents? inH$":  H  = val( inH$  ): H2 = E * H:               if H <0                             then wait
    #w.tb3 "!contents? inI$":  I  = val( inI$  ) *pi /180: #w.tb3 inI$:     if I < 0 -360 or I > 360            then wait
    #w.tb4 "!contents? inLO$": LO = val( inLO$ ) *pi /180: #w.tb4 inLO$:    if LO > 180 or LO < 0 -180          then wait
    #w.tb5 "!contents? inJ$":  J  = val( inJ$  ):                           if J <> int( J ) or J > 5 or J < 0  then wait

    #w.gb "cls ; down ; fill black ; color white ; backcolor 90 90 0 ; up ; goto 410 330 ; down"
    #w.gb "circlefilled 301 ; size 1 ; flush"

    #w.b1 "!disable"

    '   A   ( entered in +degrees) latitude above which we are viewing.
    '   LO  ( longitude) and
    '   I   ( azimuth) also entered in degrees to East and clockwise.
    '       all three internally converted to radians.
    A1     = sin( A )
    A2     = cos( A )
    H2     = E + H
    M      = acs( E / H2 )             '   max possible angle from observer to outer visible ring
    G      = E * ( H2 - E * cos( M ) ) '   scaling factor
    F      = R / ( E * sin( M ) )      '   scaling factors for two cases
    F1     = R / M


[grid]
    if J = 5 then
        #w.gb "fill black ; backcolor darkblue ; goto 0 170  ; boxfilled 780 480"
    else
        #w.gb "color 255 90 90"
        for long = -180 to 180 step 10
            for lat = -90 to 90 step 0.5
                L               =long * pi / 180    '   both in radians
                P               =lat  * pi / 180

                if J = 0 or J = 1 or J = 2 then gosub [doP1ot012]
                'calldll #kernel32, "Sleep", 100 as long, ret as void ' if want to watch slowly!
                if J = 3                   then gosub [doPlot3]
                if J = 4                   then gosub [doPlot4]
                if J = 5                   then gosub [doPlot5]
                scan
            next lat
        next long

        #w.gb "color green"
        for long = -180 to 180 step 0.5
            for lat = -90 to 90 step 10
                L               =long * pi / 180    '   both in radians
                P               =lat  * pi / 180
                if J = 0 or J = 1 or J = 2 then gosub [doP1ot012]
            'calldll #kernel32, "Sleep", 100 as long, ret as void ' if want to watch slowly!
                if J = 3                   then gosub [doPlot3]
                if J = 4                   then gosub [doPlot4]
                if J = 5                   then gosub [doPlot5]
                scan
            next lat
        next long

    end if

    #w.gb "color cyan ; size 1"

    'if your file is LF separated, convert it first to CRLF
    '   eg "sed -i 's/$/\r/' file.txt"
    'sed is a Linux stream editor, -i is used to edit the file in place, and
    '   s/$/\r/ is a substitution command that appends a carriage return (\r)
    '   to the end of each line. "file.txt" is the name of the file to convert.

    if fIn$ ="" then filedialog "Open data file, csv, CRLF separator", "dataWc.csv", fIn$
    if fIn$ ="" then fIn$ = "dataWb.csv"
    'open "dataWb.csv" for input as #fIn    'open "LatLon4.txt" for input as #fIn
    if fileOpen =0 then open fIn$ for input as #fIn
    fileOpen    =1
    line input #fIn, g$ '   discard title line

    gridDrawing = 0

    do
        line input #fIn, g$ '   lat, lon
        P   =val( word$( g$, 1, ",")) * pi / 180
        L   =val( word$( g$, 2, ",")) * pi / 180
        if J = 0 or J = 1 or J = 2 then gosub [doP1ot012]
        if J = 3                   then gosub [doPlot3]
        if J = 4                   then gosub [doPlot4]
        if J = 5                   then gosub [doPlot5]
        scan
    loop until eof( #fIn)

    close #fIn

    fileOpen =0

    #w.gb "up ; goto 40 640 ; down ; backcolor black ; color white"

    if J = 0  then #w.gb "\Perspective view"
    if J = 1  then #w.gb "\Mod'd perspective"
    if J = 2  then #w.gb "\Azimuthal equidistant"
    if J = 3  then #w.gb "\Polar Equidistant Projection"
    if J = 4  then #w.gb "\Ortho. Equatorial Projection"
    if J = 5  then #w.gb "\Lat. & Lon. plotted as Cartesian"

    #w.gb "up ; goto  40 680 ; down": #w.gb "\Latitude  "; inA$;  " ( degrees         -90 to  90    +ve=up   )"
    #w.gb "up ; goto 340 680 ; down": #w.gb "\Longitude "; inLO$; " ( degrees        -180 to 180    -ve=right)"
    #w.gb "up ; goto  40 700 ; down": #w.gb "\Altitude  "; inH$;  " ( metres         >1e8 = infinity         )"
    #w.gb "up ; goto 340 700 ; down": #w.gb "\Azimuth   "; inI$;  " ( degrees         CW or ACW from North   )"

    #w.b1 "!enable"
    '#w.b2 "!enable"

    wait

[saveScr]
    #w.gb "getbmp scr 0 0 780 725"
    filedialog "Choose a filename to save image as ", "*.bmp", fOut$
    if fOut$ ="" then fOut$ = "globe-" +str$( time$( "seconds" ) ) +".bmp"
    bmpsave "scr", fOut$
    wait

    end

'   ________________________________________________________________________________

[doP1ot012]
    '#w.b1 "!disable"
    scan
    S   = Z
    L1  = L - LO
    if L1 >= 0 -K3 then goto 3000
    L1  = L1 + K6
    goto 5500

3000
    if L1 <= K3 then goto 4000
    L1  = L1 - K6

4000
    B1  = abs( L1)
    if B1 > T then goto 4050
    D   = abs( A - P )
    if D > M  then goto 4300
    D1  = sin( D )
    D2  = cos( D )
    C   = Z
    if P >= A then goto 5000
    C   = K3
    goto 5000   '   ??? is this the correct target?
4050
    if abs( K3 - B1 ) > T then goto 4250
    D  = K3 - A - P
    if D > K3 then goto 4100
    C  = Z
    goto 4200
4100
    D  = K6 - D
    C  = K3
4200
    if D > M then goto 4300
    D1 = sin( D)
    D2 = cos( D)
    goto 5000
4250
    P1 = sin( P )
    D2 = A1 * P1 + A2 * Cos( P ) * Cos( L1 )
    D  = acs( D2)
    if D <= M then goto 4500
4300
    S = K1
    return

    return

4500
    D1  = sin( D )
    C1  = ( P1 - A1 * D2 ) / ( A2 * D1 )
    if C1 < 0 -K1 then goto 4300
    if C1 >    K1 then goto 4300

    C = acs( C1)
    if L1 >= Z    then goto 5000
    C   = K6 - C
5000
    if I = Z      then goto 5500
    C   = C - I
    if C >= Z     then goto 5500
    C   = K6 + C
5500
    C  = K2 -C

5600 if C >= 0 -K3 then goto 6000
    C  = C + K6
6000
    if J <> Z     then goto 6500
    R1 = F * ( G * D1 ) / ( H2 -E * D2 )
6250
    goto 7000
6500
    if J <> K1    then goto 6700
    R1 = F * E * D1
6600
    goto 7000
6700
    R1 = F1 * D
7000
    X   = R1 * cos( C )
    Y   = R1 * sin( C )

    'if R1 > 290 then penDown =0
    #w.gb "set ";  410 + int( X ); " "; 330 - int( Y )

    return

'   _________________________________________________________________

[doPlot3]    ' Map to polar equidistant coordinates

    H   = 0 '   Northern hemisphere: = 1 for Southern hemisphere

    if H = 0   then goto 7490
    if P > 0.0 then goto 7500

    L   = 0 - L
    goto 7540

7490 if P >= 0.0 then goto 7540

7500 S  = 1
    return

7540
    F       = 2 * R / pi
    R1      = F * ( 1.5707963 - abs( P ))

    X       = R1 * cos( L )
    Y       = R1 * sin( L )

    #w.gb "set "; 410 + int( X ); " "; 330 - int( Y )

    return

    '_______________________________________________


[doPlot4]
    '   Map to ortho equatorial coordinates
    'print P, L
    scan
    R   = 300

    S   =   0
    L   = L - LO

    if L <= 3.14159265 then 9450
    L   = L - 6.2831853
    goto 9490

9450
    if L >= 0 - 3.14159265 then 9490
    L   = L + 6.2831853

9490
    if L <  0 - 1.5707963 then 9510
    if L <=     1.5707963 then 9550

9510
    S   = 1
    return

9550
    R1  = R  * sin( 1.5707963 - abs( P ))
    X   = R1 * sin( L )
    Y   = R  * sin( P )

    #w.gb "set "; 410 + int( X ); " "; 330 - int( Y )

    return

    '   ______________________________________


[doPlot5]
    #w.gb "set "; 364 + int( 2.15 * L * 180 / pi ); " "; 330 - int( 1.6 * P * 180 / pi )
    'print P, L
    return
    '   ______________________________________

[guide]
    WindowWidth  =800
    WindowHeight =800

    open "Guidance and help" for text as #w2

    #w2 "!font Courier_New 12 bold"

    open "help.txt" for input as #fIn2
        windowOpen  = 1
        txt$        = input$( #fIn2, lof( #fIn2 ))
    close #fIn2

    windowOpen  = 0

    #w2 txt$
    wait


    '   ______________________________________

    sub quit h$
        if windowOPen = 1 then close #w2
        if fileOpen   = 1 then close #fIn
        close #h$
        end
    end sub

    '_______________________________________________

